'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @class @name BulkMailCli_booleanCommands
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @type class util
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @description Tells whether or not a bulkmail command is ran.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Date of creation: Wed, 7th Nov 2018. 12:39:28 IST
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _utilities = require('../utilities');

var _terminalKit = require('terminal-kit');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var hasArrayIncluded = require('array-includes');

var BulkMailCli_booleanCommands = function () {
    function BulkMailCli_booleanCommands() {
        _classCallCheck(this, BulkMailCli_booleanCommands);
    }

    /**
     * @method @name isHelp (@static)
     *
     * @param none
     * @returns boolean
     * 
     * @description Has user ran `bulkmail` command? Yes, or no?
     */


    _createClass(BulkMailCli_booleanCommands, null, [{
        key: 'isHelp',
        value: function isHelp() {
            if (_utilities.BulkMailCli_minimist.isArgsEmpty()) {
                return true;
            }return false;
        }

        /**
         * @method @name isVersion (@static)
         *
         * @param none
         * @returns boolean
         * 
         * @description Has user ran `bulkmail -v` command? Yes, or no?
         */

    }, {
        key: 'isVersion',
        value: function isVersion() {
            if (!_utilities.BulkMailCli_minimist.isArgsEmpty() && (_utilities.BulkMailCli_minimist.getArgs()["v"] || _utilities.BulkMailCli_minimist.getArgs()["version"])) {
                return true;
            }return false;
        }

        /**
         * @method @name isConfig (@static)
         *
         * @param none
         * @returns boolean
         * 
         * @description Has user ran `bulkmail config` command? Yes, or no?
         */

    }, {
        key: 'isConfig',
        value: function isConfig() {
            if (!_utilities.BulkMailCli_minimist.isArgsEmpty() && hasArrayIncluded(_utilities.BulkMailCli_minimist.getArgs()["_"], "config")) {
                return true;
            }return false;
        }

        /**
         * @method @name isDemo (@static)
         *
         * @param none
         * @returns boolean
         * 
         * @description Has user ran `bulkmail demo` command? Yes, or no?
         */

    }, {
        key: 'isDemo',
        value: function isDemo() {
            if (!_utilities.BulkMailCli_minimist.isArgsEmpty() && hasArrayIncluded(_utilities.BulkMailCli_minimist.getArgs()["_"], "demo")) {
                return true;
            }return false;
        }

        /**
         * @method @name hasPressedCtrlC (@static)
         *
         * @param none
         * @returns boolean
         * 
         * @description Has user pressed `Ctrl_C` command? Yes, or no?
         */

    }, {
        key: 'hasPressedCtrlC',
        value: function hasPressedCtrlC() {
            _terminalKit.terminal.on('key', function (key, matches, data) {
                switch (key) {
                    case 'CTRL_C':
                        // process.stdout.write("\u001b[2J\u001b[0;0H");
                        process.exit();
                        return true;
                    default:
                        return false;
                }
            });
        }

        /**
         * @method @name isMail (@static)
         *
         * @param none
         * @returns boolean
         * 
         * @description Has user typed `bulkmail mail` command? Yes, or no?
         */

    }, {
        key: 'isMail',
        value: function isMail() {
            if (!_utilities.BulkMailCli_minimist.isArgsEmpty() && hasArrayIncluded(_utilities.BulkMailCli_minimist.getArgs()["_"], "mail")) {
                return true;
            }return false;
        }
    }]);

    return BulkMailCli_booleanCommands;
}();

exports.default = BulkMailCli_booleanCommands;