'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @class @name BulkMailCli_commands
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @type class util
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @description Does different things for different bulkmail commands
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Date of creation: Sun, 4th Nov 2018. 10:43:17 IST
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _utilities = require('../utilities');

var _i18n = require('../i18n');

var _i18n2 = _interopRequireDefault(_i18n);

var _booleanCommands = require('./booleanCommands.class');

var _booleanCommands2 = _interopRequireDefault(_booleanCommands);

var _terminalKit = require('terminal-kit');

var _tools = require('./tools');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var isHelp = _booleanCommands2.default.isHelp,
    isVersion = _booleanCommands2.default.isVersion,
    isConfig = _booleanCommands2.default.isConfig,
    isDemo = _booleanCommands2.default.isDemo,
    isMail = _booleanCommands2.default.isMail,
    hasPressedCtrlC = _booleanCommands2.default.hasPressedCtrlC;
var getText = _i18n2.default.getText;

var BulkMailCli_commands = function () {
    function BulkMailCli_commands() {
        _classCallCheck(this, BulkMailCli_commands);

        this.CtrlC();

        if (isHelp()) {
            this.help();
        } else if (isVersion()) {
            this.version();
        } else if (isMail()) {
            this.mail();
        } else if (isConfig()) {
            this.config();
        } else if (isDemo()) {
            this.demo();
        } else {
            this.wrongCommand();
        }
    }

    /**
     * @method @name help (Not @static)
     *
     * @param none
     * @returns void
     * 
     * @description Provides help info when no arguments are provided.
     */


    _createClass(BulkMailCli_commands, [{
        key: 'help',
        value: function help() {
            (0, _tools.help)();
        }

        /**
         * @method @name version (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @description Provides version name.
         */

    }, {
        key: 'version',
        value: function version() {
            (0, _tools.version)();
        }

        /**
         * @method @name mail (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @description To do the main task.
         */

    }, {
        key: 'mail',
        value: function mail() {
            new _tools.BulkMailCli_mail().mail();
        }

        /**
         * @method @name config (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @description Used to change user configs in the CLI.
         */

    }, {
        key: 'config',
        value: function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                if (!_utilities.BulkMailCli_minimist.getArgs()["lang"]) {
                                    _context.next = 4;
                                    break;
                                }

                                (0, _tools.selectLang)();
                                _context.next = 16;
                                break;

                            case 4:
                                if (!_utilities.BulkMailCli_minimist.getArgs()["username"]) {
                                    _context.next = 8;
                                    break;
                                }

                                (0, _tools.changeUsername)();
                                _context.next = 16;
                                break;

                            case 8:
                                if (!_utilities.BulkMailCli_minimist.getArgs()["auth"]) {
                                    _context.next = 15;
                                    break;
                                }

                                _context.next = 11;
                                return new _tools.BulkMailCli_authSession().authSession();

                            case 11:
                                console.log("\n");
                                process.exit();
                                _context.next = 16;
                                break;

                            case 15:
                                _terminalKit.terminal.red.bold('' + getText("wrong_bulkmail_config_command"));

                            case 16:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function config() {
                return _ref.apply(this, arguments);
            }

            return config;
        }()

        /**
         * @method @name demo (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @description Used to copy demo files to local machine
         */

    }, {
        key: 'demo',
        value: function demo() {
            (0, _tools.demo)();
        }

        /**
         * @method @name CtrlC (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @description This method streams the ON KEY event.
         */

    }, {
        key: 'CtrlC',
        value: function CtrlC() {
            hasPressedCtrlC();
        }

        /**
         * @method @name wrongCommand (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @description Renders when an unknown argument or command is used.
         */

    }, {
        key: 'wrongCommand',
        value: function wrongCommand() {
            _terminalKit.terminal.red.bold('' + getText("wtf_was_that"));
        }
    }]);

    return BulkMailCli_commands;
}();

exports.default = BulkMailCli_commands;