'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.BulkMailCli_authSession = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @class @name BulkMailCli_authSession
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @type class util
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @description Runs an authSession when asked.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Date of creation: Mon, 12th Nov 2018. 16:45:22 IST
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _terminalKit = require('terminal-kit');

var _settings = require('../../settings');

var _settings2 = _interopRequireDefault(_settings);

var _i18n = require('../../i18n');

var _i18n2 = _interopRequireDefault(_i18n);

var _utilities = require('../../utilities');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var setSettings = _settings2.default.setSettings,
    getSettings = _settings2.default.getSettings;
var getText = _i18n2.default.getText;


var credentialsArray = [];
var settingsObject = getSettings();
credentialsArray.push(settingsObject);

var BulkMailCli_authSession = function () {
    function BulkMailCli_authSession() {
        _classCallCheck(this, BulkMailCli_authSession);
    }

    /**
     * @method @name authSession (Not @static)
     *
     * @param none
     * @returns Promise
     * 
     * @async Please use this method only in async functions.
     *        DO NOT FORGET TO PUT AN `await` before calling this function.
     * 
     * @description Used to set auth/service credentials.
     */


    _createClass(BulkMailCli_authSession, [{
        key: 'authSession',
        value: function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
                var _this = this;

                return regeneratorRuntime.wrap(function _callee4$(_context4) {
                    while (1) {
                        switch (_context4.prev = _context4.next) {
                            case 0:

                                _terminalKit.terminal.yellow.bold('' + getText("fill_service_credentials"));

                                _context4.next = 3;
                                return this.chooseService().then(function () {
                                    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(service) {
                                        return regeneratorRuntime.wrap(function _callee$(_context) {
                                            while (1) {
                                                switch (_context.prev = _context.next) {
                                                    case 0:
                                                        _context.next = 2;
                                                        return _this.serviceAnalyser(service);

                                                    case 2:
                                                    case 'end':
                                                        return _context.stop();
                                                }
                                            }
                                        }, _callee, _this);
                                    }));

                                    return function (_x) {
                                        return _ref2.apply(this, arguments);
                                    };
                                }());

                            case 3:
                                _context4.next = 5;
                                return this.enterEmail();

                            case 5:
                                _context4.next = 7;
                                return this.enterPassword();

                            case 7:

                                _terminalKit.terminal.yellow.bold('' + getText("connecting"));

                                _context4.next = 10;
                                return new Promise(function () {
                                    var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(resolve, reject) {
                                        return regeneratorRuntime.wrap(function _callee3$(_context3) {
                                            while (1) {
                                                switch (_context3.prev = _context3.next) {
                                                    case 0:
                                                        _context3.next = 2;
                                                        return _this.isSuccessful(credentialsArray[0]).then(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
                                                            return regeneratorRuntime.wrap(function _callee2$(_context2) {
                                                                while (1) {
                                                                    switch (_context2.prev = _context2.next) {
                                                                        case 0:
                                                                            _context2.prev = 0;
                                                                            _context2.next = 3;
                                                                            return setSettings(credentialsArray[0]);

                                                                        case 3:
                                                                            _terminalKit.terminal.green.bold('' + getText("connected"));
                                                                            resolve(true);
                                                                            _context2.next = 10;
                                                                            break;

                                                                        case 7:
                                                                            _context2.prev = 7;
                                                                            _context2.t0 = _context2['catch'](0);

                                                                            console.log(_context2.t0);

                                                                        case 10:
                                                                        case 'end':
                                                                            return _context2.stop();
                                                                    }
                                                                }
                                                            }, _callee2, _this, [[0, 7]]);
                                                        }))).catch(function () {
                                                            _terminalKit.terminal.red.bold('' + getText("wrong_credentials"));
                                                            resolve(false);
                                                        });

                                                    case 2:
                                                    case 'end':
                                                        return _context3.stop();
                                                }
                                            }
                                        }, _callee3, _this);
                                    }));

                                    return function (_x2, _x3) {
                                        return _ref3.apply(this, arguments);
                                    };
                                }());

                            case 10:
                                return _context4.abrupt('return', _context4.sent);

                            case 11:
                            case 'end':
                                return _context4.stop();
                        }
                    }
                }, _callee4, this);
            }));

            function authSession() {
                return _ref.apply(this, arguments);
            }

            return authSession;
        }()

        /**
         * @method @name chooseService (Not @static)
         *
         * @param none
         * @returns Promise
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Does the work of rendering a service selection field.
         */

    }, {
        key: 'chooseService',
        value: function () {
            var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
                var _this2 = this;

                var servicesToSelect, serviceSelected;
                return regeneratorRuntime.wrap(function _callee6$(_context6) {
                    while (1) {
                        switch (_context6.prev = _context6.next) {
                            case 0:

                                _terminalKit.terminal.cyan.bold('' + getText("please_choose_service"));

                                servicesToSelect = ['gmail', 'yahoo', 'other/custom'];
                                serviceSelected = new Promise(function (resolve, reject) {
                                    _terminalKit.terminal.singleColumnMenu(servicesToSelect, function () {
                                        var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(error, response) {
                                            var serviceName;
                                            return regeneratorRuntime.wrap(function _callee5$(_context5) {
                                                while (1) {
                                                    switch (_context5.prev = _context5.next) {
                                                        case 0:
                                                            serviceName = response.selectedText;

                                                            credentialsArray[0].service = serviceName;
                                                            resolve(serviceName);

                                                        case 3:
                                                        case 'end':
                                                            return _context5.stop();
                                                    }
                                                }
                                            }, _callee5, _this2);
                                        }));

                                        return function (_x4, _x5) {
                                            return _ref6.apply(this, arguments);
                                        };
                                    }());
                                });
                                return _context6.abrupt('return', serviceSelected);

                            case 4:
                            case 'end':
                                return _context6.stop();
                        }
                    }
                }, _callee6, this);
            }));

            function chooseService() {
                return _ref5.apply(this, arguments);
            }

            return chooseService;
        }()

        /**
         * @method @name serviceAnalyser (Not @static)
         *
         * @param {*} service - Service selected (string)
         * @returns void
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Does the work of rendering a SecureConnection yesOrNo input field.
         */

    }, {
        key: 'serviceAnalyser',
        value: function () {
            var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(service) {
                return regeneratorRuntime.wrap(function _callee7$(_context7) {
                    while (1) {
                        switch (_context7.prev = _context7.next) {
                            case 0:
                                if (!(service == "gmail")) {
                                    _context7.next = 7;
                                    break;
                                }

                                _terminalKit.terminal.yellow.bold('' + getText("less_secure_apps"));
                                credentialsArray[0].host = "smtp.gmail.com";
                                credentialsArray[0].port = 465;
                                credentialsArray[0].secureConnection = true;
                                _context7.next = 21;
                                break;

                            case 7:
                                if (!(service == "yahoo")) {
                                    _context7.next = 13;
                                    break;
                                }

                                credentialsArray[0].host = "smtp.mail.yahoo.com";
                                credentialsArray[0].port = 465;
                                credentialsArray[0].secureConnection = true;
                                _context7.next = 21;
                                break;

                            case 13:
                                if (!(service == "other/custom")) {
                                    _context7.next = 21;
                                    break;
                                }

                                console.log("");
                                _context7.next = 17;
                                return this.enterHost();

                            case 17:
                                _context7.next = 19;
                                return this.enterPort();

                            case 19:
                                _context7.next = 21;
                                return this.secureConnection();

                            case 21:
                            case 'end':
                                return _context7.stop();
                        }
                    }
                }, _callee7, this);
            }));

            function serviceAnalyser(_x6) {
                return _ref7.apply(this, arguments);
            }

            return serviceAnalyser;
        }()

        /**
         * @method @name enterHost (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Does the work of rendering a host input field.
         */

    }, {
        key: 'enterHost',
        value: function () {
            var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
                var input;
                return regeneratorRuntime.wrap(function _callee8$(_context8) {
                    while (1) {
                        switch (_context8.prev = _context8.next) {
                            case 0:
                                _terminalKit.terminal.cyan.bold('' + getText("please_enter_host"));
                                _context8.next = 3;
                                return _terminalKit.terminal.inputField().promise;

                            case 3:
                                input = _context8.sent;

                                credentialsArray[0].host = input;

                            case 5:
                            case 'end':
                                return _context8.stop();
                        }
                    }
                }, _callee8, this);
            }));

            function enterHost() {
                return _ref8.apply(this, arguments);
            }

            return enterHost;
        }()

        /**
         * @method @name enterPort (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Does the work of rendering a Port input field.
         */

    }, {
        key: 'enterPort',
        value: function () {
            var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
                var input;
                return regeneratorRuntime.wrap(function _callee9$(_context9) {
                    while (1) {
                        switch (_context9.prev = _context9.next) {
                            case 0:
                                _terminalKit.terminal.cyan.bold('' + getText("please_enter_port"));
                                _context9.next = 3;
                                return _terminalKit.terminal.inputField().promise;

                            case 3:
                                input = _context9.sent;

                                credentialsArray[0].port = input;

                            case 5:
                            case 'end':
                                return _context9.stop();
                        }
                    }
                }, _callee9, this);
            }));

            function enterPort() {
                return _ref9.apply(this, arguments);
            }

            return enterPort;
        }()

        /**
         * @method @name secureConnection (Not @static)
         *
         * @param none
         * @returns Promise
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Does the work of rendering a SecureConnection yesOrNo input field.
         */

    }, {
        key: 'secureConnection',
        value: function () {
            var _ref10 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
                return regeneratorRuntime.wrap(function _callee10$(_context10) {
                    while (1) {
                        switch (_context10.prev = _context10.next) {
                            case 0:

                                _terminalKit.terminal.cyan.bold('' + getText("secure_connection_question"));

                                _context10.next = 3;
                                return new Promise(function (resolve, reject) {
                                    _terminalKit.terminal.yesOrNo({ yes: ['y'], no: ['n'] }, function (error, result) {
                                        if (result) {
                                            _terminalKit.terminal.green.bold('' + getText("yes_for_sc"));
                                            credentialsArray[0].secureConnection = true;
                                            resolve();
                                        } else {
                                            _terminalKit.terminal.red.bold('' + getText("no_for_sc"));
                                            credentialsArray[0].secureConnection = false;
                                            resolve();
                                        }
                                    });
                                });

                            case 3:
                                return _context10.abrupt('return', _context10.sent);

                            case 4:
                            case 'end':
                                return _context10.stop();
                        }
                    }
                }, _callee10, this);
            }));

            function secureConnection() {
                return _ref10.apply(this, arguments);
            }

            return secureConnection;
        }()

        /**
         * @method @name enterEmail (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Does the work of rendering an email input field.
         */

    }, {
        key: 'enterEmail',
        value: function () {
            var _ref11 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11() {
                var input;
                return regeneratorRuntime.wrap(function _callee11$(_context11) {
                    while (1) {
                        switch (_context11.prev = _context11.next) {
                            case 0:
                                _terminalKit.terminal.cyan.bold('' + getText("please_enter_email"));
                                _context11.next = 3;
                                return _terminalKit.terminal.inputField().promise;

                            case 3:
                                input = _context11.sent;

                                credentialsArray[0].email = input;

                            case 5:
                            case 'end':
                                return _context11.stop();
                        }
                    }
                }, _callee11, this);
            }));

            function enterEmail() {
                return _ref11.apply(this, arguments);
            }

            return enterEmail;
        }()

        /**
         * @method @name enterPassword (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Does the work of rendering a password input field.
         */

    }, {
        key: 'enterPassword',
        value: function () {
            var _ref12 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12() {
                var input;
                return regeneratorRuntime.wrap(function _callee12$(_context12) {
                    while (1) {
                        switch (_context12.prev = _context12.next) {
                            case 0:
                                _terminalKit.terminal.cyan.bold('' + getText("please_enter_password"));
                                _context12.next = 3;
                                return _terminalKit.terminal.inputField({ echoChar: '•' }).promise;

                            case 3:
                                input = _context12.sent;

                                credentialsArray[0].password = input;

                            case 5:
                            case 'end':
                                return _context12.stop();
                        }
                    }
                }, _callee12, this);
            }));

            function enterPassword() {
                return _ref12.apply(this, arguments);
            }

            return enterPassword;
        }()

        /**
         * @method @name isSuccessful (Not @static)
         *
         * @param credentials - (object)
         * @returns Promise (boolean resolve)
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Checks if the service credentials are valid.
         */

    }, {
        key: 'isSuccessful',
        value: function () {
            var _ref13 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13(credentials) {
                var smtpOptions, isSuccessful;
                return regeneratorRuntime.wrap(function _callee13$(_context13) {
                    while (1) {
                        switch (_context13.prev = _context13.next) {
                            case 0:
                                smtpOptions = {
                                    host: credentials.host,
                                    port: credentials.port,
                                    secureConnection: credentials.secureConnection,
                                    auth: {
                                        user: credentials.email,
                                        pass: credentials.password
                                    }
                                };
                                isSuccessful = new Promise(function (resolve, reject) {
                                    (0, _utilities.checkConnection)(smtpOptions, function (error, success) {
                                        if (success == true) {
                                            resolve(true);
                                        } else {
                                            reject(false);
                                        }
                                    });
                                });
                                _context13.next = 4;
                                return isSuccessful;

                            case 4:
                                return _context13.abrupt('return', _context13.sent);

                            case 5:
                            case 'end':
                                return _context13.stop();
                        }
                    }
                }, _callee13, this);
            }));

            function isSuccessful(_x7) {
                return _ref13.apply(this, arguments);
            }

            return isSuccessful;
        }()
    }]);

    return BulkMailCli_authSession;
}();

exports.BulkMailCli_authSession = BulkMailCli_authSession;