'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.changeUsername = undefined;

var _terminalKit = require('terminal-kit');

var _settings = require('../../settings');

var _settings2 = _interopRequireDefault(_settings);

var _i18n = require('../../i18n');

var _i18n2 = _interopRequireDefault(_i18n);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var setSetting = _settings2.default.setSetting,
    getSetting = _settings2.default.getSetting;
var getText = _i18n2.default.getText;

/**
 * @function @name changeUsername
 *
 * @param none
 * @returns void
 * 
 * @description Used to let a user change his/her username.
 */

var changeUsername = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var input;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:

            _terminalKit.terminal.yellow.bold(getText("your_current_username", "jointTexts", 1) + ' ' + getSetting("username") + getText("your_current_username", "jointTexts", 2));

            _terminalKit.terminal.cyan.bold('' + getText("please_enter_username"));

            _context.next = 4;
            return _terminalKit.terminal.inputField().promise;

          case 4:
            input = _context.sent;
            _context.next = 7;
            return setSetting("username", input);

          case 7:

            _terminalKit.terminal.green.bold(getText("your_new_username", "jointTexts", 1) + ' ' + getSetting("username") + getText("your_new_username", "jointTexts", 2));

            process.exit();

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function changeUsername() {
    return _ref.apply(this, arguments);
  };
}();

exports.changeUsername = changeUsername;