'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.demo = undefined;

var _terminalKit = require('terminal-kit');

var _ncp = require('ncp');

var _i18n = require('../../i18n');

var _i18n2 = _interopRequireDefault(_i18n);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var getText = _i18n2.default.getText;


var SOURCE_PATH = require('bulkmailcli_settings').PROJECT_DIR + '/src/dist/src/assets/demo';
var DESTINATION_PATH = process.cwd();

/**
 * @function @name demo
 *
 * @param none
 * @returns void
 * 
 * @description Used to show demo files to the user.
 */
var demo = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:

                        _terminalKit.terminal.yellow.bold('' + getText("generating_demo"));

                        (0, _ncp.ncp)(SOURCE_PATH, DESTINATION_PATH, function (error) {
                            if (error) {
                                _terminalKit.terminal.red.bold('' + getText("failed"));
                            } else {
                                _terminalKit.terminal.green.bold('' + getText("look_at_desktop"));
                            }
                        });

                    case 2:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, undefined);
    }));

    return function demo() {
        return _ref.apply(this, arguments);
    };
}();

exports.demo = demo;