'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.help = undefined;

var _terminalKit = require('terminal-kit');

var _settings = require('../../settings');

var _settings2 = _interopRequireDefault(_settings);

var _i18n = require('../../i18n');

var _i18n2 = _interopRequireDefault(_i18n);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getSetting = _settings2.default.getSetting;
var getText = _i18n2.default.getText;

/**
 * @function @name help
 *
 * @param none
 * @returns void
 * 
 * @description Used to render help text.
 */

var help = function help() {

    // These lines of code are better. NOT to indent.  
    _terminalKit.terminal.yellow.bold(getText("hey_comma") + ' ' + getSetting("username") + '! ').green.bold('' + getText("bmc_here")).white.italic('' + getText("one_liner_description")).white.bold('' + getText("underestimating")).white('' + getText("read_doc")).yellow.bold('' + getText("usage")).cyan.bold('bulkmail <command> [options]\n\n').yellow.bold('' + getText("commands_and_options")).cyan('\n    config\n        --auth ^y: To change the service credentials.\n        ^c--lang ^y: To change the language preference.\n        ^c--username ^y: To change your default username.\n\n    ^cdemo ^y: To download the demo email templates and .csv file.\n        ^c<no options>^\n    \n    ^cmail ^y: To mass mail the data you fed!!\n        ^c<no options>^\n    \n    ^y -v, --version ^\n\n').yellow.bold('' + getText("happy_bulkmailing"));
};

exports.help = help;