'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.BulkMailCli_mail = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @class @name BulkMailCli_mail
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @type class util
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @description Runs a mail session when asked.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Date of creation: Sat, 24th Nov 2018. 8:16:31 IST
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _terminalKit = require('terminal-kit');

var _fs = require('fs');

var _settings = require('../../settings');

var _settings2 = _interopRequireDefault(_settings);

var _i18n = require('../../i18n');

var _i18n2 = _interopRequireDefault(_i18n);

var _tools = require('../tools');

var _utilities = require('../../utilities');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var getSetting = _settings2.default.getSetting;
var getText = _i18n2.default.getText;


var csvToJson = require('csvtojson');
var isOnline = require('is-online');

var BulkMailCli_mail = function () {
    function BulkMailCli_mail() {
        _classCallCheck(this, BulkMailCli_mail);

        this.csvJson = '';
        this.htmlFile = '';
        this.fromText = '';
        this.subject = '';
        this.isSuccess = false;
    }

    /**
     * @method @name isAuthSession (Not @static)
     *
     * @param none
     * @returns boolean
     * 
     * @description Are user's auth credentials registered? Yes, or no?
     */


    _createClass(BulkMailCli_mail, [{
        key: 'isAuthSession',
        value: function isAuthSession() {
            if (getSetting("email")) {
                return true;
            }return false;
        }

        /**
         * @method @name mail (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Renders the mailSession
         */

    }, {
        key: 'mail',
        value: function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                if (this.isAuthSession()) {
                                    _context.next = 3;
                                    break;
                                }

                                _context.next = 3;
                                return new _tools.BulkMailCli_authSession().authSession().then(function (isSuccessful) {
                                    if (!isSuccessful) {
                                        _terminalKit.terminal.red.bold('' + getText("cannot_mail_wrong_credentials"));
                                        process.exit();
                                    }
                                });

                            case 3:

                                _terminalKit.terminal.yellow.bold('' + getText("fill_wisely"));

                                _context.next = 6;
                                return this.pathToCsv();

                            case 6:
                                _context.next = 8;
                                return this.pathToHtml();

                            case 8:
                                _context.next = 10;
                                return this.enterFromName();

                            case 10:
                                _context.next = 12;
                                return this.enterSubject();

                            case 12:
                                _context.next = 14;
                                return this.mailMassacre();

                            case 14:

                                process.exit();

                            case 15:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function mail() {
                return _ref.apply(this, arguments);
            }

            return mail;
        }()

        /**
         * @method @name pathToCsv (Not @static)
         *
         * @param none
         * @returns Promise
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Renders CSV file browser
         */

    }, {
        key: 'pathToCsv',
        value: function () {
            var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
                var _this = this;

                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:

                                _terminalKit.terminal.cyan.bold('' + getText("choose_csv_path"));

                                _context3.next = 3;
                                return new Promise(function (resolve, reject) {
                                    _terminalKit.terminal.fileInput({ baseDir: process.cwd() }, function () {
                                        var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(error, input) {
                                            var csvPath;
                                            return regeneratorRuntime.wrap(function _callee2$(_context2) {
                                                while (1) {
                                                    switch (_context2.prev = _context2.next) {
                                                        case 0:
                                                            if (!error) {
                                                                _context2.next = 5;
                                                                break;
                                                            }

                                                            _terminalKit.terminal.red.bold('\n' + error);
                                                            reject();
                                                            _context2.next = 25;
                                                            break;

                                                        case 5:
                                                            if (!((0, _utilities.doesFileExist)(input) && _utilities.BulkMailCli_checkFileType.isCsv(input))) {
                                                                _context2.next = 21;
                                                                break;
                                                            }

                                                            csvPath = input;
                                                            _context2.next = 9;
                                                            return csvToJson().fromFile(csvPath);

                                                        case 9:
                                                            _this.csvJson = _context2.sent;

                                                            if (!(_this.csvJson.length == 0 || !("email" in _this.csvJson[0]))) {
                                                                _context2.next = 17;
                                                                break;
                                                            }

                                                            _terminalKit.terminal.red.bold('' + getText("column_missing"));
                                                            _context2.next = 14;
                                                            return _this.pathToCsv();

                                                        case 14:
                                                            resolve();
                                                            _context2.next = 19;
                                                            break;

                                                        case 17:
                                                            _terminalKit.terminal.green.bold(' "' + input + '" ' + getText("input_selected"));
                                                            resolve();

                                                        case 19:
                                                            _context2.next = 25;
                                                            break;

                                                        case 21:
                                                            _terminalKit.terminal.red.bold('' + getText("file_not_found_csv"));
                                                            _context2.next = 24;
                                                            return _this.pathToCsv();

                                                        case 24:
                                                            resolve();

                                                        case 25:
                                                        case 'end':
                                                            return _context2.stop();
                                                    }
                                                }
                                            }, _callee2, _this);
                                        }));

                                        return function (_x, _x2) {
                                            return _ref3.apply(this, arguments);
                                        };
                                    }());
                                });

                            case 3:
                                return _context3.abrupt('return', _context3.sent);

                            case 4:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this);
            }));

            function pathToCsv() {
                return _ref2.apply(this, arguments);
            }

            return pathToCsv;
        }()

        /**
         * @method @name pathToHtml (Not @static)
         *
         * @param none
         * @returns Promise
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Renders Html file browser
         */

    }, {
        key: 'pathToHtml',
        value: function () {
            var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
                var _this2 = this;

                return regeneratorRuntime.wrap(function _callee5$(_context5) {
                    while (1) {
                        switch (_context5.prev = _context5.next) {
                            case 0:

                                _terminalKit.terminal.cyan.bold('' + getText("choose_html_path"));

                                _context5.next = 3;
                                return new Promise(function (resolve, reject) {
                                    _terminalKit.terminal.fileInput({ baseDir: process.cwd() }, function () {
                                        var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(error, input) {
                                            var htmlPath;
                                            return regeneratorRuntime.wrap(function _callee4$(_context4) {
                                                while (1) {
                                                    switch (_context4.prev = _context4.next) {
                                                        case 0:
                                                            if (!error) {
                                                                _context4.next = 5;
                                                                break;
                                                            }

                                                            _terminalKit.terminal.red.bold('\n' + error);
                                                            reject();
                                                            _context4.next = 16;
                                                            break;

                                                        case 5:
                                                            if (!((0, _utilities.doesFileExist)(input) && _utilities.BulkMailCli_checkFileType.isHtml(input))) {
                                                                _context4.next = 12;
                                                                break;
                                                            }

                                                            htmlPath = input;

                                                            _this2.htmlFile = (0, _fs.readFileSync)(htmlPath, "utf8");

                                                            _terminalKit.terminal.green.bold(' "' + input + '" ' + getText("input_selected"));
                                                            resolve();

                                                            _context4.next = 16;
                                                            break;

                                                        case 12:
                                                            _terminalKit.terminal.red.bold('' + getText("file_not_found_html"));
                                                            _context4.next = 15;
                                                            return _this2.pathToHtml();

                                                        case 15:
                                                            resolve();

                                                        case 16:
                                                        case 'end':
                                                            return _context4.stop();
                                                    }
                                                }
                                            }, _callee4, _this2);
                                        }));

                                        return function (_x3, _x4) {
                                            return _ref5.apply(this, arguments);
                                        };
                                    }());
                                });

                            case 3:
                                return _context5.abrupt('return', _context5.sent);

                            case 4:
                            case 'end':
                                return _context5.stop();
                        }
                    }
                }, _callee5, this);
            }));

            function pathToHtml() {
                return _ref4.apply(this, arguments);
            }

            return pathToHtml;
        }()

        /**
         * @method @name enterFromName (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Does the work of rendering a From name input field.
         */

    }, {
        key: 'enterFromName',
        value: function () {
            var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
                var input;
                return regeneratorRuntime.wrap(function _callee6$(_context6) {
                    while (1) {
                        switch (_context6.prev = _context6.next) {
                            case 0:
                                _terminalKit.terminal.cyan.bold('' + getText("please_enter_from"));
                                _context6.next = 3;
                                return _terminalKit.terminal.inputField().promise;

                            case 3:
                                input = _context6.sent;

                                this.fromText = input;

                            case 5:
                            case 'end':
                                return _context6.stop();
                        }
                    }
                }, _callee6, this);
            }));

            function enterFromName() {
                return _ref6.apply(this, arguments);
            }

            return enterFromName;
        }()

        /**
         * @method @name enterSubject (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Does the work of rendering a subject input field.
         */

    }, {
        key: 'enterSubject',
        value: function () {
            var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
                var input;
                return regeneratorRuntime.wrap(function _callee7$(_context7) {
                    while (1) {
                        switch (_context7.prev = _context7.next) {
                            case 0:
                                _terminalKit.terminal.cyan.bold('' + getText("please_enter_subject"));
                                _context7.next = 3;
                                return _terminalKit.terminal.inputField().promise;

                            case 3:
                                input = _context7.sent;

                                this.subject = input;

                            case 5:
                            case 'end':
                                return _context7.stop();
                        }
                    }
                }, _callee7, this);
            }));

            function enterSubject() {
                return _ref7.apply(this, arguments);
            }

            return enterSubject;
        }()

        /**
         * @method @name mailInterval (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Does the work of asking users INTERVAL TIME.
         */

    }, {
        key: 'mailInterval',
        value: function () {
            var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
                var _this3 = this;

                var intervalsToSelect, intervalSelected;
                return regeneratorRuntime.wrap(function _callee9$(_context9) {
                    while (1) {
                        switch (_context9.prev = _context9.next) {
                            case 0:

                                _terminalKit.terminal.cyan.bold('Choose time interval for shooting mails \uD83D\uDD2B');

                                intervalsToSelect = ['Just shoot \'em!', 'Mail every 2 seconds', 'Mail every 5 seconds', 'Mail every 15 seconds', 'Mail every 30 seconds'];
                                intervalSelected = new Promise(function (resolve, reject) {
                                    _terminalKit.terminal.singleColumnMenu(intervalsToSelect, function () {
                                        var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(error, response) {
                                            var interval;
                                            return regeneratorRuntime.wrap(function _callee8$(_context8) {
                                                while (1) {
                                                    switch (_context8.prev = _context8.next) {
                                                        case 0:
                                                            interval = response.selectedIndex;

                                                            _this3.interval = interval;
                                                            resolve(interval);

                                                        case 3:
                                                        case 'end':
                                                            return _context8.stop();
                                                    }
                                                }
                                            }, _callee8, _this3);
                                        }));

                                        return function (_x5, _x6) {
                                            return _ref9.apply(this, arguments);
                                        };
                                    }());
                                });
                                return _context9.abrupt('return', intervalSelected);

                            case 4:
                            case 'end':
                                return _context9.stop();
                        }
                    }
                }, _callee9, this);
            }));

            function mailInterval() {
                return _ref8.apply(this, arguments);
            }

            return mailInterval;
        }()

        /**
         * @method @name mailMassacre (Not @static)
         *
         * @param none
         * @returns void
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description SHOOT THE CRAP OUT OF DATA!!!
         */

    }, {
        key: 'mailMassacre',
        value: function () {
            var _ref10 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11() {
                var _this4 = this;

                var smtpOptions;
                return regeneratorRuntime.wrap(function _callee11$(_context11) {
                    while (1) {
                        switch (_context11.prev = _context11.next) {
                            case 0:

                                this.mailSentTo = [];

                                _terminalKit.terminal.yellow.bold('' + getText("mailer_started"));

                                smtpOptions = {
                                    host: getSetting('host'),
                                    port: getSetting('port'),
                                    secure: getSetting('secureConnection'),
                                    auth: {
                                        user: getSetting('email'),
                                        pass: getSetting('password')
                                    },
                                    tls: { rejectUnauthorized: false }
                                };
                                _context11.next = 5;
                                return Promise.all(this.csvJson.map(function () {
                                    var _ref11 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(user) {
                                        var mailer;
                                        return regeneratorRuntime.wrap(function _callee10$(_context10) {
                                            while (1) {
                                                switch (_context10.prev = _context10.next) {
                                                    case 0:
                                                        _context10.next = 2;
                                                        return isOnline();

                                                    case 2:
                                                        if (!_context10.sent) {
                                                            _context10.next = 8;
                                                            break;
                                                        }

                                                        mailer = new _utilities.BulkMailCli_mailer(user.email, (0, _utilities.htmlProcessor)(_this4.htmlFile, user), smtpOptions, _this4.fromText, (0, _utilities.htmlProcessor)(_this4.subject, user));
                                                        _context10.next = 6;
                                                        return mailer.sendMail().then(function (isSuccessful) {

                                                            if (isSuccessful) {
                                                                _this4.isSuccess = true;
                                                                _this4.mailSentTo.push(user.email);
                                                                _terminalKit.terminal.green(getText("mail_sent_to") + ' ' + user.email);
                                                            } else {
                                                                return;
                                                                // terminal.red(`${getText("check_internet_connection")}`)
                                                            }
                                                        }).catch(function (error) {
                                                            _this4.isSuccess = false;
                                                            _this4.mailError = error;
                                                            return;
                                                        });

                                                    case 6:
                                                        _context10.next = 11;
                                                        break;

                                                    case 8:
                                                        _this4.isSuccess = false;
                                                        _this4.mailError = getText("mail_lost_connection");
                                                        return _context10.abrupt('return');

                                                    case 11:
                                                    case 'end':
                                                        return _context10.stop();
                                                }
                                            }
                                        }, _callee10, _this4);
                                    }));

                                    return function (_x7) {
                                        return _ref11.apply(this, arguments);
                                    };
                                }())).then(function () {
                                    console.log("\n");
                                    if (_this4.mailSentTo.length === _this4.csvJson.length) {
                                        _terminalKit.terminal.green.bold('' + getText("mail_done_successfully"));
                                    } else {
                                        _terminalKit.terminal.yellow.bold('' + (_this4.mailError === undefined ? '' : _this4.mailError + '\n') + (_this4.mailSentTo.length > 0 ? '' : '^r') + 'Mail sent to ' + (_this4.mailSentTo.length > 0 ? _this4.mailSentTo.length : 'no') + ' recipient' + (_this4.mailSentTo.length < 2 ? '' : 's') + ' out of ' + _this4.csvJson.length + ' people listed in the CSV file.\n\n');
                                    }
                                });

                            case 5:
                            case 'end':
                                return _context11.stop();
                        }
                    }
                }, _callee11, this);
            }));

            function mailMassacre() {
                return _ref10.apply(this, arguments);
            }

            return mailMassacre;
        }()
    }]);

    return BulkMailCli_mail;
}();

exports.BulkMailCli_mail = BulkMailCli_mail;