'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.selectLang = undefined;

var _terminalKit = require('terminal-kit');

var _settings = require('../../settings');

var _settings2 = _interopRequireDefault(_settings);

var _i18n = require('../../i18n');

var _i18n2 = _interopRequireDefault(_i18n);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var setSetting = _settings2.default.setSetting;
var getText = _i18n2.default.getText;

/**
 * @function @name selectLang
 *
 * @param none
 * @returns void
 * 
 * @description Used to let a user select language.
 */

var selectLang = function selectLang() {

    _terminalKit.terminal.yellow.bold('' + getText("please_select_lang"));

    var languagesToSelect = ['en: English', 'cn: Chinese'];

    _terminalKit.terminal.singleColumnMenu(languagesToSelect, function () {
        var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(error, response) {
            var langCode, language;
            return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            langCode = response.selectedText.substring(0, 2); // Select only the Language code from the items of languagesToSelect

                            language = response.selectedText.substring(4, response.selectedText.length); // Select only the Language name from the items of languagesToSelect

                            _context.next = 4;
                            return setSetting("lang", langCode);

                        case 4:

                            _terminalKit.terminal.green.bold(getText("you_are_now_a_lang_person", "jointTexts", 1) + ' ' + getText(language) + ' ' + getText("you_are_now_a_lang_person", "jointTexts", 2));

                            process.exit();

                        case 6:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, undefined);
        }));

        return function (_x, _x2) {
            return _ref.apply(this, arguments);
        };
    }());
};

exports.selectLang = selectLang;