'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @class @name BulkMailCli_i18n
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @type class util
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @description Renders the same text, but in different languages.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Date of creation: Wed, 1st Nov 2018. 19:52:18 IST
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _settings = require('../settings');

var _settings2 = _interopRequireDefault(_settings);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var getSetting = _settings2.default.getSetting;

var strings = require('./strings.json');

var BulkMailCli_i18n = function () {
    function BulkMailCli_i18n() {
        _classCallCheck(this, BulkMailCli_i18n);
    }

    /**
     * @method @name getText (@static)
     * 
     * @param string - String to render from strings.json (string) (mandatory)
     * @param textType <"texts": default> or <"jointTexts"> (string)
     * @param stringNumber <1: default> (integer) 
     * 
     * @returns string <value> or false
     * 
     * @description Returns the text of the configurated language...
     */


    _createClass(BulkMailCli_i18n, null, [{
        key: 'getText',
        value: function getText(string) {
            var textType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "texts";
            var stringNumber = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;


            try {
                if (textType == "texts") {
                    var value = strings.texts[string][getSetting("lang")];
                    return value;
                } else if (textType == "jointTexts") {
                    var value = strings.jointTexts[string][stringNumber][getSetting("lang")];
                    return value;
                } else {
                    console.log("textType could only be of two types, <texts> or <jointTexts>.");
                    return false;
                }
            } catch (error) {
                console.log("Provided label <" + string + "> at stringNumber <" + stringNumber + "> for configured language <" + this.getSetting("lang") + "> does not exist.");
                return false;
            }
        }
    }]);

    return BulkMailCli_i18n;
}();

exports.default = BulkMailCli_i18n;