'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @class @name BulkMailCli
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @type main class
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @description Initializes BulkMailCli from start to end
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Date of creation: Fri, 2nd Nov 2018. 21:39:31 IST
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _utilities = require('./utilities');

var _settings = require('./settings');

var _settings2 = _interopRequireDefault(_settings);

var _os = require('os');

var _terminalKit = require('terminal-kit');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var osName = require('os-name');

/**
 * @summary Needed these two for using new .js language features
 *          When you don't import these, regeneratorRuntime error pops up.
 *          You can't run asynchronous functions without these modules.
 * @see https://stackoverflow.com/questions/33527653/babel-6-regeneratorruntime-is-not-defined
 */
require("@babel/register");
require("@babel/polyfill");

var bulkmail = _utilities.BulkMailCli_minimist.bulkmail;
var setSetting = _settings2.default.setSetting,
    getSettings = _settings2.default.getSettings;

var BulkMailCli = function () {
    function BulkMailCli() {
        _classCallCheck(this, BulkMailCli);
    }

    /**
     * @method @name create (Not @static)
     * @param none
     * @returns void
     * @description Initializes at every BulkMailCli command
     */


    _createClass(BulkMailCli, [{
        key: 'create',
        value: function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                if (!((0, _os.platform)() == 'darwin' || (0, _os.platform)() == 'linux')) {
                                    _context.next = 6;
                                    break;
                                }

                                _context.next = 3;
                                return this.setSettings();

                            case 3:
                                bulkmail();
                                _context.next = 7;
                                break;

                            case 6:
                                _terminalKit.terminal.red.bold('\nSorry, ^ybulk-mail-cli v' + BulkMailCli.getVersion() + '^ fails to support ^c' + osName((0, _os.platform)(), (0, _os.release)()) + '^c \u2639\uFE0F\n\n');

                            case 7:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function create() {
                return _ref.apply(this, arguments);
            }

            return create;
        }()

        /**
         * @method @name setSettings (Not @static)
         * @param none
         * @async This has to be an async function due to compulsory use of `await` before `setSetting()`.
         * @returns void
         * @description Sets all the required settings to run bulkmail cli.
         */

    }, {
        key: 'setSettings',
        value: function () {
            var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                if (!BulkMailCli.isFirstTime()) {
                                    _context2.next = 13;
                                    break;
                                }

                                _context2.next = 3;
                                return setSetting("userInfo", (0, _os.userInfo)());

                            case 3:
                                _context2.next = 5;
                                return setSetting("username", (0, _os.userInfo)().username);

                            case 5:
                                _context2.next = 7;
                                return setSetting("hostname", (0, _os.hostname)());

                            case 7:
                                _context2.next = 9;
                                return setSetting("platform", (0, _os.platform)());

                            case 9:
                                _context2.next = 11;
                                return setSetting("release", (0, _os.release)());

                            case 11:
                                _context2.next = 13;
                                return setSetting("lang", "en");

                            case 13:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function setSettings() {
                return _ref2.apply(this, arguments);
            }

            return setSettings;
        }()

        /**
         * @method @name isFirstTime (@static)
         * @param none
         * @returns boolean
         * @description Tells whether the command ran in regard of bulkmail is for the first time or not.
         */

    }], [{
        key: 'isFirstTime',
        value: function isFirstTime() {
            if (JSON.stringify(getSettings()) == JSON.stringify({})) {
                return true;
            }return false;
        }

        /**
         * @method @name getVersion (@static)
         * @param none
         * @returns string
         * @description Returns the version number of bulk-mail-cli.
         */

    }, {
        key: 'getVersion',
        value: function getVersion() {
            var SOURCE_PATH = require('bulkmailcli_settings').PROJECT_DIR + '/package.json';
            var packageJson = require(SOURCE_PATH);
            return packageJson.version;
        }
    }]);

    return BulkMailCli;
}();

exports.default = BulkMailCli;