"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @class @name BulkMailCli_settings
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @type util
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @description Manages configs for the user.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Date of creation: Fri, 2nd Nov 2018. 2:34:18 IST
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _utilities = require("../utilities");

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * @summary Needed these two for using new .js language features
 *          When you don't import these, regeneratorRuntime error pops up.
 *          You can't run asynchronous functions without these modules.
 * @see https://stackoverflow.com/questions/33527653/babel-6-regeneratorruntime-is-not-defined
 */
require("@babel/register");
require("@babel/polyfill");

/**
 * @uses BulkMailCli_settings
 * @summary BulkMailCli_settings was required for solving issue #4. [Solved]
 * @see https://github.com/KumarAbhirup/bulk-mail-cli/issues/4
 */
var SETTINGS_PATH = require('bulkmailcli_settings').PROJECT_DIR + '/src/dist/src/lib/settings/settings.json';

var BulkMailCli_settings = function () {

    /**
     * @method @name constructor (@constructor)
     * 
     * @param none
     * @returns object <settings>
     * 
     * @description To instantiate an updated settings variable everytime.
     */
    function BulkMailCli_settings() {
        _classCallCheck(this, BulkMailCli_settings);

        var settings = require(SETTINGS_PATH);
        return settings;
    }

    /**
     * @method @name getSetting (@static)
     * 
     * @param setting - The setting you need from settings.json file (string)
     * @returns string <setting> or false
     * 
     * @description Returns the needed setting or configuration.
     */


    _createClass(BulkMailCli_settings, null, [{
        key: "getSetting",
        value: function getSetting(setting) {
            var settings = new BulkMailCli_settings();
            if (settings[setting] != null) {
                return settings[setting];
            } else {
                // console.log("Provided setting <" + setting + "> cannot be found.")
                return false;
            }
        }

        /**
         * @method @name getSettings (@static)
         * 
         * @param none
         * @returns object
         * 
         * @description Returns the `settings` object
         */

    }, {
        key: "getSettings",
        value: function getSettings() {
            var settings = new BulkMailCli_settings();
            return settings;
        }

        /**
         * @method @name setSetting (@static)
         *
         * @param setting - What is the setting/configuration that you wanna save? (string)
         * @param value - What is the value that you wanna assign to the new/updated setting/configuration? (string)
         * 
         * @returns Promise or false
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @summary This method had a major bug. [SOLVED]
         * @see https://github.com/KumarAbhirup/bulk-mail-cli/issues/3 [SOLVED]
         * 
         * @description Saves a new setting.
         */

    }, {
        key: "setSetting",
        value: function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(setting, value) {
                var settings, data, doneSetting;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                settings = new BulkMailCli_settings();
                                _context.prev = 1;


                                settings[setting] = null;
                                settings[setting] = value;

                                data = JSON.stringify(settings); // JSON.stringify(settings, null, 2) for tabbed spaces and styling

                                _context.next = 7;
                                return (0, _utilities.writeFileForPromise)(SETTINGS_PATH, data);

                            case 7:
                                if (!_context.sent) {
                                    _context.next = 14;
                                    break;
                                }

                                doneSetting = new Promise(function (resolve, reject) {
                                    resolve(settings);
                                });
                                _context.next = 11;
                                return doneSetting;

                            case 11:
                                return _context.abrupt("return", _context.sent);

                            case 14:
                                return _context.abrupt("return", false);

                            case 15:
                                _context.next = 21;
                                break;

                            case 17:
                                _context.prev = 17;
                                _context.t0 = _context["catch"](1);
                                console.log(_context.t0);return _context.abrupt("return", false);

                            case 21:
                            case "end":
                                return _context.stop();
                        }
                    }
                }, _callee, this, [[1, 17]]);
            }));

            function setSetting(_x, _x2) {
                return _ref.apply(this, arguments);
            }

            return setSetting;
        }()

        /**
         * @method @name setSettings (@static)
         *
         * @param allSettings - Complete `settings` object which is to be saved. (object)
         * 
         * @returns Promise or false
         * 
         * @async Please use this method only in async functions.
         *        DO NOT FORGET TO PUT AN `await` before calling this function.
         * 
         * @description Saves a complete settings object.
         */

    }, {
        key: "setSettings",
        value: function () {
            var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(allSettings) {
                var data, doneSetting;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                _context2.prev = 0;
                                data = JSON.stringify(allSettings);
                                _context2.next = 4;
                                return (0, _utilities.writeFileForPromise)(SETTINGS_PATH, data);

                            case 4:
                                if (!_context2.sent) {
                                    _context2.next = 11;
                                    break;
                                }

                                doneSetting = new Promise(function (resolve, reject) {
                                    resolve(allSettings);
                                });
                                _context2.next = 8;
                                return doneSetting;

                            case 8:
                                return _context2.abrupt("return", _context2.sent);

                            case 11:
                                return _context2.abrupt("return", false);

                            case 12:
                                _context2.next = 18;
                                break;

                            case 14:
                                _context2.prev = 14;
                                _context2.t0 = _context2["catch"](0);
                                console.log(_context2.t0);return _context2.abrupt("return", false);

                            case 18:
                            case "end":
                                return _context2.stop();
                        }
                    }
                }, _callee2, this, [[0, 14]]);
            }));

            function setSettings(_x3) {
                return _ref2.apply(this, arguments);
            }

            return setSettings;
        }()
    }]);

    return BulkMailCli_settings;
}();

exports.default = BulkMailCli_settings;