'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.doesFileExist = undefined;

var _fs = require('fs');

/**
 * @function @name doesFileExist
 *
 * @param {string} filePath - Path to be checked for its existence.
 * @returns boolean
 * 
 * @description Used for checking if the file exists or not.
 */
var doesFileExist = exports.doesFileExist = function doesFileExist(filePath) {
    try {
        return (0, _fs.statSync)(filePath).isFile();
    } catch (error) {
        return false;
    }
};