'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.htmlProcessor = undefined;

var _replaceString = require('replace-string');

var _replaceString2 = _interopRequireDefault(_replaceString);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var REGEX = /\(\{#(.*?)#\}\)/g;
var toReplace = [];
var swapOutWith = [];

/**
 * @function @name htmlProcessor
 *
 * @param {string} html
 * @param {object} data
 * 
 * @returns boolean
 * 
 * @description DYNAMICISM 🍿
 */
var htmlProcessor = exports.htmlProcessor = function htmlProcessor(html, data) {

  var finalOutput = html;

  var regexArray = html.match(REGEX);
  if (regexArray != null) {
    for (var i = 0; i < regexArray.length; i++) {
      var string = regexArray[i];
      swapOutWith.push(string.substring(3, string.length - 3));
      toReplace.push('({#' + string.substring(3, string.length - 3) + '#})');
    }
  }

  for (var i = 0; i < toReplace.length; i++) {
    finalOutput = (0, _replaceString2.default)(finalOutput, toReplace[i], data[swapOutWith[i]]);
  }

  return finalOutput;
};